#!/bin/bash

#DIR1="/usr/local/lib/python3.10/dist-packages/paho_mqtt-2.1.0.dist-info"
#DIR2="/usr/local/lib/python3.10/dist-packages/paho_mqtt-1.6.1.dist-info"

if ! sqlite3 "/usr/local/rs485/data.db" "PRAGMA table_info(listening);" | grep -q fport; then
        sqlite3 "/usr/local/rs485/data.db" "ALTER TABLE listening ADD COLUMN fport TEXT;" &> /dev/null
fi

if find /usr/local/lib/python*/dist-packages/paho*/ -type d -print -quit | grep -q .; then
        #python3 /usr/local/dragino/rs485/mqtt.py &
        #pid1=$!

        slave_address=$(uci -q get modbus.rtu.slave_address)
        slave_port=$(uci -q get modbus.tcp.slave_port)
        slave_mode=$(uci -q get modbus.general.mode)
        baudrate=$(uci -q get modbus.rtu.baudrate)
        if [[ -z $baudrate ]]; then
                baudrate=9600
        fi

        if [[ $slave_mode = RTU || -z $slave_mode ]]; then
                python3 /usr/local/dragino/rs485/modbus_downlink.py &
                pid3=$!
		sleep 2
                if [[ -f /var/iot/hardware  || $(dragino-sid grep MODULE|grep  83525680 -c) -gt 0 ]]; then
                        /usr/local/bin/dragino_m4x_slave -s $slave_address -b $baudrate
                else
        		/usr/local/bin/dragino_m4x_slave -s $slave_address -b $baudrate -hardware 1
                fi
                pid2=$!
        elif [[ $slave_mode = TCP ]]; then
                python3 /usr/local/dragino/rs485/modbus_downlink.py &
                pid3=$!
		sleep 2
                /usr/local/bin/dragino_m4x_slave -p $slave_port
                pid2=$!
        fi

        wait $pid2 $pid3
else
        node /usr/local/rs485/mqtt/app.js &
        pid1=$!

        slave_address=$(uci -q get modbus.rtu.slave_address)
        slave_port=$(uci -q get modbus.tcp.slave_port)
        slave_mode=$(uci -q get modbus.general.mode)
        baudrate=$(uci -q get modbus.rtu.baudrate)
        if [[ -z $baudrate ]]; then
                baudrate=9600
	fi

        if [[ $slave_mode = RTU || -z $slave_mode ]]; then
                python3 /usr/local/dragino/rs485/modbus_downlink.py &
                /usr/local/bin/dragino_m4x_slave -s $slave_address -b $baudrate
        elif [[ $slave_mode = TCP ]]; then
                python3 /usr/local/dragino/rs485/modbus_downlink.py &
                /usr/local/bin/dragino_m4x_slave -p $slave_port
        fi
fi